import pygame
import math

#utils functions - loading things
from utils import *

#vector2d
from vector2d import *



class Camera:
	location = None
	frustrum = None
	#screen_dimensions = None
	scaling = None
	
	#setting up for chasing cam - NOT THIS COMPO =(
	target = None;
	
	tightness = 10
	
	def __init__(self, initial_location, width, height, screen_width, screen_height):
		self.location = initial_location.copy()
		self.frustrum = Vector2d((width/2, height/2))
		#self.screen_dimensions = (screen_width, screen_height)
		self.target = self.location.copy()
		self.scaling = (float(width) / float(screen_width), float(height) / float(screen_height))
		
	def update(self, delta_time):
		#move ourselves closer to the target.
		connect_vector = self.target - self.location
		#print connect_vector
		dis = float(connect_vector.Magnitude())
		#print dis
		if math.fabs(dis) > EPSILON:
			#RARARARARARAAAAAAAAARARARARARARAAAAAAAAARARARARARARAAAAAAAAARARARARARARAAAAAAAAA
			#factor = delta_time / 2.
			self.location += connect_vector #.Normalize().Mul(factor)
			# factor = ((self.tightness * dis * (delta_time / 1000.)) / 2.)
			# if math.fabs(factor) > EPSILON:
				# self.location += connect_vector.Mul(factor)
	
	def set_target(self, new_target):
		self.target = new_target
	
	def get_screen_coords(self, world_point):
		vec = (world_point - self.location) + self.frustrum
		return vec.tup()
	
	def rect_to_screen(self, a_rect):
		the_rect = a_rect.copy()
		world_point = Vector2d(the_rect.center)
		[x, y] = self.get_screen_coords(world_point)
		the_rect.center = [x, y]
		return the_rect
		
		# a_rect.width *= self.scaling[0]
		# a_rect.height *= self.scaling[1]
