import math

import pygame
from pygame.locals import *

class Safezone:
	surface = None

	def __init__(self, size_vec):
		self.surface = pygame.Surface.convert_alpha(pygame.Surface(size_vec.tup()))
		self.surface.fill((255,255,255, 255))
		radius_sqr = float((size_vec.x/2)**2)

		for i in range(0, int(size_vec.x)):
			for j in range(0, int(size_vec.x)):
				alph = 255 * (1 - ((i - size_vec.x/2)**2 + (j - size_vec.y/2)**2) / radius_sqr)
				alph = int(alph)
				if alph > 255: alph = 255
				if alph < 0 : alph = 0
				self.surface.set_at((i, j), Color(255,255,255, int(alph)))
		
		
	def GetSurface(self):
		return self.surface
		
	def GetRect(self):
		return self.surface.get_rect(center=(0,0))